<mat-stepper [orientation]="(stepperOrientation | async)!">
  <!--    GENERAL     -->
  <mat-step label="General Information">
    <form [formGroup]="profileForm">
      <div class="generalForm">
        <div class="generalFormList">
          <h2>General</h2>
          <div class="blackLine"></div>

          <mat-form-field class="title">
            <mat-label>Title of institution</mat-label>
            <input matInput formControlName="title">
            <mat-error *ngIf="profileForm.get('title')!.value.length != 0">Max length is {{Global.textFormFieldsLength}} characters.</mat-error>
          </mat-form-field>
          <mat-form-field class="shortcut">
            <mat-label>Shortcut</mat-label>
            <input matInput formControlName="shortcut">
            <mat-error *ngIf="profileForm.get('shortcut')!.value.length != 0">Max length is {{Global.textFormFieldsLength}} characters.</mat-error>
          </mat-form-field>
          <mat-form-field class="organization">
            <mat-label>Overlying organization</mat-label>
            <input matInput formControlName="organization">
            <mat-error *ngIf="profileForm.get('organization')!.value.length != 0">Max length is {{Global.textFormFieldsLength}} characters.</mat-error>
          </mat-form-field>
          <mat-form-field class="website">
            <mat-label>Link to external website</mat-label>
            <input matInput formControlName="external_link">
            <!-- <mat-error *ngIf="general.get('external_link')!.value.length != 0">Max length is {{Global.textFormFieldsLength}} characters.</mat-error> -->
          </mat-form-field>
        </div>

        <div class="generalFormList">
          <h2>Address</h2>
          <div class="blackLine"></div>

          <mat-form-field class="street">
            <mat-label>Street and house number</mat-label>
            <input matInput formControlName="street">
            <mat-error *ngIf="profileForm.get('street')!.value.length != 0">Max length is {{Global.textFormFieldsLength}} characters.</mat-error>
          </mat-form-field>
          <mat-form-field class="zip">
            <mat-label>ZIP</mat-label>
            <input matInput formControlName="zip">
            <mat-error *ngIf="profileForm.get('zip')!.value.length != 0">Max length is {{Global.textFormFieldsLength}} characters.</mat-error>
          </mat-form-field>
          <mat-form-field class="city">
            <mat-label>City</mat-label>
            <input matInput formControlName="city">
            <mat-error *ngIf="profileForm.get('city')!.value.length != 0">Max length is {{Global.textFormFieldsLength}} characters.</mat-error>
          </mat-form-field>
          <mat-form-field class="country">
            <mat-label>Country</mat-label>
            <input matInput formControlName="country">
            <mat-error *ngIf="profileForm.get('country')!.value.length != 0">Max length is {{Global.textFormFieldsLength}} characters.</mat-error>
          </mat-form-field>
        </div>

        <div class="generalFormList">
          <h2>Logo</h2>
          <div class="blackLine"></div>

          <app-upload-box
            matInput
            [defaultFile]="profileForm.get('logo')!.value"
            [allowedTypes]="['png', 'jpeg', 'jpg', 'webp', 'svg']"
            [fileClass]="'logos'"
            [form]="profileForm"
            [controlName]="'logo'"
            (uploadStarted)="blockFormSubmit('logo')"
            (uploadFinished)="unblockFormSubmit('logo')"
            (fileNameReturn)="updateFile(this.profileForm, 'logo', $event.filename)"
            class="institutionImage"
          />
        </div>

        <div class="institute">
          <h2>Choose or create the institution to which the profile belongs.</h2>
          <p>Note: This is usually the same as the overlying organization!</p>
          <div class="instituteInner">
            <app-select-and-filter
              *ngIf="instituteList"
              [list]="instituteList"
              [defaultSelection]="this.profileForm.get('institute')!.value"
              [label]="'Filter list of institutions'"
              [placeholder]="'Institutions'"
              [multiple]="false"
              (selectedListChanged)="selectionChanged($event, 'institute')"
            />
            <button
              mat-fab
              color="primary"
              matTooltip="Clear selection"
              (click)="
                this.profileForm.patchValue({ institute: null });
              ">
              <mat-icon>close</mat-icon>
            </button>
            <button
              mat-fab
              color="primary"
              matTooltip="Create new institution"
              (click)="openDialog('institute')"
              aria-label="Create new institution"
            >
              <mat-icon>add</mat-icon>
            </button>
          </div>
        </div>
      </div>

      <div class="navigation">
        <button mat-icon-button matStepperPrevious color="primary" aria-label="back">
          <mat-icon>keyboard_arrow_left</mat-icon>
        </button>
        <button mat-icon-button matStepperNext color="primary" aria-label="forward">
          <mat-icon>keyboard_arrow_right</mat-icon>
        </button>
      </div>
    </form>
  </mat-step>

  <!--    REPRESENTATIVES     -->
  <mat-step label="Representatives">
    <div [formGroup]="profileForm" class="repContainer">

      <div *ngIf="profileForm.controls['people'].hasError('invalidPositions')" class="repError">
        At least one maintainer and one representative are required.
      </div>

      <div formArrayName="people" class="representatives">
        <ng-container *ngFor="let peopleControls of people.controls; let i = index">
          <div [formGroup]="getPeopleFormGroup(i)" class="representative">

            <mat-form-field class="firstname">
              <mat-label>Firstname</mat-label>
              <input matInput formControlName="firstname">
              <mat-error *ngIf="getPeopleFormGroup(i).get('firstname')!.value.length != 0">
                Max length is {{Global.textFormFieldsLength}} characters.
              </mat-error>
            </mat-form-field>
            <mat-form-field class="lastname">
              <mat-label>Lastname</mat-label>
              <input matInput formControlName="lastname">
              <mat-error *ngIf="getPeopleFormGroup(i).get('lastname')!.value.length != 0">
                Max length is {{Global.textFormFieldsLength}} characters.
              </mat-error>
            </mat-form-field>
            <mat-form-field class="title">
              <mat-label>Title</mat-label>
              <input matInput formControlName="title">
              <mat-error *ngIf="getPeopleFormGroup(i).get('title')!.value.length != 0">
                Max length is {{Global.textFormFieldsLength}} characters.
              </mat-error>
            </mat-form-field>
            <mat-form-field class="e-mail">
              <mat-label>E-mail</mat-label>
              <input matInput formControlName="email">
              <mat-error *ngIf="getPeopleFormGroup(i).get('email')!.value.length != 0">
                Max length is {{Global.textFormFieldsLength}} characters.
              </mat-error>
            </mat-form-field>
            <mat-form-field class="position">
              <mat-label>Position</mat-label>
              <mat-select formControlName="position">
                <mat-option value="representative">Representative</mat-option>
                <mat-option value="maintainer">Maintainer</mat-option>
              </mat-select>
            </mat-form-field>
            <mat-form-field class="orc">
              <mat-label>ORC-ID</mat-label>
              <input matInput formControlName="orc_id">
              <ng-container *ngIf="getPeopleFormGroup(i).get('orc_id')?.value">
                <mat-error *ngIf="getPeopleFormGroup(i).get('orc_id')!.value.length != 19">
                  The Length of the ORC ID should be 20 Characters (including dashes).
                </mat-error>
              </ng-container>
            </mat-form-field>

            <app-upload-box
              matInput
              [description]="'Image of the person'"
              [allowedTypes]="['png', 'jpeg', 'jpg', 'webp', 'svg']"
              [fileClass]="'representatives'"
              [defaultFile]="this.getPeopleFormGroup(i).get('photo')!.value"
              [form]="this.getPeopleFormGroup(i)"
              [controlName]="'photo'"
              (uploadStarted)="blockFormSubmit('photo')"
              (uploadFinished)="unblockFormSubmit('photo')"
              (fileNameReturn)="peopleControls.get('photo')!.setValue($event.filename)"
              class="repImage"
            />

            <button mat-mini-fab color="primary" (click)="deletePerson(i)" class="delRep">
              <mat-icon>delete_forever</mat-icon>
            </button>
          </div>

        </ng-container>
        <div class="addRep" (click)="addPersonToForm()">
          <button mat-mini-fab>
            <mat-icon>add</mat-icon>
          </button>
        </div>
      </div>

      <div class="navigation">
        <button mat-icon-button matStepperPrevious color="primary" aria-label="back">
          <mat-icon>keyboard_arrow_left</mat-icon>
        </button>
        <button mat-icon-button matStepperNext color="primary" aria-label="forward">
          <mat-icon>keyboard_arrow_right</mat-icon>
        </button>
      </div>
    </div>
  </mat-step>

  <!--    RESEARCH OVERVIEW     -->
  <mat-step label="Research Overview">
    <form [formGroup]="profileForm" class="overviewForm">

      <div class="gridContainer">
        <div class="overviewTopSplit">
          <mat-form-field class="description">
            <mat-label>Description</mat-label>
            <textarea matInput formControlName="description" rows="7"></textarea>
            <mat-error *ngIf="profileForm.get('description')!.touched && profileForm.get('description')!.invalid">
              {{ getErrorMessage('description', Global.textAreaFormFieldsLength) }}
            </mat-error>
            <!-- <ng-container *ngIf="profileForm.get('description')!.value as desc">
            </ng-container> -->
          </mat-form-field>
          <mat-form-field class="research_focus">
            <mat-label>Research Focus</mat-label>
            <textarea matInput formControlName="research_focus" rows="7"></textarea>
            <mat-hint>A new line will generate a bullet point.</mat-hint>
            <mat-error *ngIf="profileForm.get('research_focus')!.touched && profileForm.get('research_focus')!.invalid">
              {{ getErrorMessage('research_focus', Global.textAreaFormFieldsLength) }}
            </mat-error>
          </mat-form-field>
        </div>
        <div></div>

        <app-select-and-filter
          *ngIf="projectList"
          [list]="projectList"
          [defaultSelection]="this.profileForm.get('projects')!.value"
          [label]="'Filter Project List'"
          [placeholder]="'Projects'"
          (selectedListChanged)="selectionChanged($event, 'projects')"
        />
        <button mat-fab color="primary"
          (click)="openDialog('projects')" aria-label="Create new project">
          <mat-icon>add</mat-icon>
        </button>

        <app-select-and-filter
          *ngIf="labList"
          [list]="labList"
          [defaultSelection]="this.profileForm.get('labs')!.value"
          [label]="'Filter Lab List'"
          [placeholder]="'Labs'"
          (selectedListChanged)="selectionChanged($event, 'labs')"
        />
        <button mat-fab color="primary" (click)="openDialog('labs')" aria-label="Create new project">
          <mat-icon>add</mat-icon>
        </button>
      </div>

      <div class="navigation">
        <button mat-icon-button matStepperPrevious color="primary" aria-label="back">
          <mat-icon>keyboard_arrow_left</mat-icon>
        </button>
        <button mat-icon-button matStepperNext color="primary" aria-label="forward">
          <mat-icon>keyboard_arrow_right</mat-icon>
        </button>
      </div>
    </form>
  </mat-step>

  <!--    RESEARCH NETWORKS     -->
  <mat-step label="Research Networks">
    <form [formGroup]="profileForm">

      <app-select-and-filter
        *ngIf="networkList"
        [list]="networkList"
        [defaultSelection]="this.profileForm.get('networks')!.value"
        [label]="'Filter Network List'"
        [placeholder]="'Networks'"
        (selectedListChanged)="selectionChanged($event, 'networks')"
      />

      <div class="navigation">
        <button mat-icon-button matStepperPrevious color="primary" aria-label="back">
          <mat-icon>keyboard_arrow_left</mat-icon>
        </button>
        <button mat-icon-button matStepperNext color="primary" aria-label="forward">
          <mat-icon>keyboard_arrow_right</mat-icon>
        </button>
      </div>
    </form>
  </mat-step>

  <!--    RESEARCH FOCUS / CLUSTERS     -->
  <mat-step label="Research Cluster">
    <form [formGroup]="profileForm">
      <p><b>First</b> explore existing clusters matching your research foci.</p>

      <app-select-and-filter
        *ngIf="clusterList"
        [list]="clusterList"
        [defaultSelection]="this.profileForm.get('clusters')!.value"
        [label]="'Filter Cluster List'"
        [placeholder]="'Clusters'"
        (selectedListChanged)="selectionChanged($event, 'clusters')"
      />

      <div class="lineContainer">
        <div class="line"></div>
      </div>

      <div class="newFocus">
        <p style="margin: 0">
          <b>Second</b>, if you have a research focus that does not align with the available ones, propose your own focus. <br>
          Others can then join your focus, creating a cluster for shared research pursuits.
        </p>
        <button mat-raised-button (click)="openDialog('clusters')">Create new focus</button>
      </div>

      <div class="navigation">
        <button mat-icon-button matStepperPrevious color="primary" aria-label="back">
          <mat-icon>keyboard_arrow_left</mat-icon>
        </button>
        <button mat-icon-button matStepperNext color="primary" aria-label="forward">
          <mat-icon>keyboard_arrow_right</mat-icon>
        </button>
      </div>
    </form>
  </mat-step>

  <!--    PUBLICATIONS     -->
  <mat-step label="Publications">
    <form [formGroup]="profileForm">
      <div class="publicationFileDropper">
        <app-upload-box
          matInput
          [description]="'Publication File in the bib format.'"
          [allowedTypes]="['bib']"
          [fileClass]="'publications'"
          [defaultFile]="this.profileForm.get('publications_file')!.value"
          [form]="profileForm"
          [controlName]="'publications_file'"
          (uploadStarted)="blockFormSubmit('publications_file')"
          (uploadFinished)="unblockFormSubmit('publications_file')"
          (fileNameReturn)="updateFile(this.profileForm, 'publications_file', $event.filename)"
        />
      </div>

      <div class="navigation">
        <button
          mat-icon-button
          matStepperPrevious
          color="primary"
          aria-label="back"
        >
          <mat-icon>keyboard_arrow_left</mat-icon>
        </button>
        <div matTooltip="Check if all required forms are filled out." [matTooltipDisabled]="profileForm.valid">
          <button
            mat-fab
            extended
            color="primary"
            aria-label="save"
            [disabled]="!(profileForm.valid)"
            (click)="submit()"
          >
            <mat-icon>send</mat-icon>
            <span *ngIf="id">Update profile</span>
            <span *ngIf="!id">Create profile</span>
          </button>
        </div>
        <mat-spinner
          #spinner
          [ngStyle]="{'display': spinnerVisible ? 'block' : 'none'}"
          style="width: 40px; margin-left: 20px;"
        ></mat-spinner>
      </div>
    </form>
  </mat-step>
</mat-stepper>
